dot/bashrc: Improvements for handling schroot(1) environments.
[profile] / dot / bashrc
1 ### -*-bash-*-
2 ###
3 ### Bash session things
4
5 ## Only do this if we haven't done it before. (Note that this guard isn't
6 ## exported, so subshells will need to make their own arrangements.)
7 if [ -z "$__mdw_bashrc" ]; then
8 __mdw_bashrc=done
9
10 ## If we've not run the main profile yet, we should do that first. It sets
11 ## up things we rely on. Also, if there's a system script, we should run
12 ## that too.
13 [ -z "$__mdw_profile" -a -r $HOME/.bash_profile ] && . $HOME/.bash_profile
14 [ -r /etc/bashrc ] && . /etc/bashrc
15
16 ## Completion.
17 [ -r /etc/bash_completion ] && . /etc/bash_completion
18 [ -r $HOME/.bash_completion ] && . $HOME/.bash_completion
19
20 ## Set the temporary directory again. (If we've switched users, we'll want a
21 ## different temporary directory.)
22 [ "${TMPDIR+yes}" ] || eval `tmpdir -b`
23
24 ###--------------------------------------------------------------------------
25 ### Prompt hacking.
26
27 ## Only bother if the shell is interactive.
28 if [ -t 0 ]; then
29
30 ## Fancy highlighting in some terminals.
31 marker=${STY+'\[\ek\e\\\]'}
32 case "$TERM" in
33 linux*|screen*|xterm*|vt100*|eterm*)
34 case "$(tput bold)" in
35 "") bold="\[$(tput md)\]" unbold="\[$(tput me)\]" ;;
36 *) bold="\[$(tput bold)\]" unbold="\[$(tput sgr0)\]" ;;
37 esac
38 gitcolour="\[$(tput setaf 6)\]"
39 rccolour="\[$(tput setaf 1)\]"
40 uncolour="\[$(tput op)\]"
41 nl="\[ \]"
42 ;;
43 *)
44 bold='' unbold='' nl='' gitcolour='' rccolour='' uncolour='';;
45 esac
46
47 ## Choose the right delimiters. Highlight root prompts specially;
48 ## highlight when I'm running as some other user. Highlight when this
49 ## isn't the outermost shell on the terminal.
50 if (( EUID == 0 )); then
51 left=`echo « | iconv -f UTF-8 -t //translit`
52 right=`echo » | iconv -f UTF-8 -t //translit`
53 else
54 case $USER in
55 mdw|mwooding|nemo) u="" left="[" right="]" ;;
56 *) u="\\u@" left="{" right="}" ;;
57 esac
58 if [ "$__mdw_tty" = "`tty`" ]; then
59 left="<" right=">"
60 else
61 export __mdw_tty="`tty`"
62 fi
63 fi
64
65 ## If this session is insecure then highlight that.
66 if [ -z "$SSH_CLIENT" ] && [ -z "$SCHROOT_CHROOT_NAME" ] &&
67 [ "$__mdw_sechost" != "`hostname`" ]
68 then
69 sec_l='(' sec_r=')'
70 fi
71
72 ## If this is an schroot environment then point this out.
73 hqual=""
74 hqual="$hqual${SCHROOT_CHROOT_NAME+/$SCHROOT_CHROOT_NAME}"
75
76 ## Build the prompt string.
77 if type __git_ps1 >/dev/null 2>&1; then
78 git="$unbold$gitcolour\$(rc=\$?;__git_ps1;exit \$rc)$uncolour$bold"
79 else
80 git=""
81 fi
82 rc="$unbold$rccolour\$(rc=\$?;case \$rc in 0);;"
83 rc="$rc*)echo -n \" rc=\$rc\";;esac;exit \$rc)$uncolour$bold"
84 PS1="$nl$bold$left$sec_l$u\\h$hqual$sec_r \\w$git$rc$marker$right$unbold"
85 PS2="$PS1 $bold>$unbold "
86 unset nl bold unbold left right sec_l sec_r marker
87 unset gitcolour rccolour uncolour git rc hqual
88 fi
89
90 ###--------------------------------------------------------------------------
91 ### Other shell tweaking.
92
93 ## Random shell tweaks.
94 notify=1
95 set -b
96 shopt -u cdable_vars
97 shopt -s cdspell
98 shopt -s checkhash
99 shopt -s checkwinsize
100 shopt -s cmdhist
101 shopt -u dotglob
102 shopt -s expand_aliases
103 shopt -s extglob
104 if (( ${BASH_VERSINFO[0]} >= 4 )); then shopt -s globstar; fi
105 shopt -s gnu_errfmt
106 shopt -s histappend
107 shopt -s histreedit
108 shopt -u histverify
109 shopt -s hostcomplete
110 shopt -s huponexit
111 shopt -s interactive_comments
112 shopt -s lithist
113 shopt -u mailwarn
114 shopt -u nocaseglob
115 shopt -u nullglob
116 shopt -s promptvars
117 shopt -u shift_verbose
118 shopt -s sourcepath
119 HISTCONTROL=ignorespace:erasedups
120
121 ## Some handy aliases.
122 alias cx='chmod a+x'
123 alias which="command -v"
124 alias rc="rc -l"
125 alias ssync="rsync -e ssh"
126 rootly () {
127 case $# in 0) set -- "${SHELL-/bin/sh}" ;; esac
128 $__MDW_ROOTLY "$@"
129 }
130 alias r=rootly
131 alias re="rootly $EDITOR"
132 alias pstree="pstree -hl"
133 alias cdtmp='cd ${TMPDIR-/tmp}'
134 alias pushtmp='pushd ${TMPDIR-/tmp}'
135 alias e="$EDITOR"
136 alias svn="svnwrap svn"
137 alias @="ssh"
138
139 ###--------------------------------------------------------------------------
140 ### Colour output.
141
142 ## Arrange for `ls' output to be in colour.
143 if [ -x /usr/bin/dircolors -o -x /usr/local/bin/dircolors ]; then
144 eval `dircolors -b ~/.dircolors`
145 else
146 unset LS_COLORS
147 fi
148
149 unalias ls 2>/dev/null || :; function ls () {
150 if [ -t 1 ]; then
151 command ls $LS_OPTIONS ${LS_COLORS+--color=auto} "$@"
152 else
153 command ls "$@"
154 fi
155 }
156
157 ## Arrange for `grep' output to be in colour.
158 export GREP_COLORS="mt=01;31:ms=01;31:mc=031;31:fn=36:ln=36:bn=36:se=34"
159
160 greplike () {
161 declare grep=$1; shift
162 if [ -t 1 ]; then
163 command $grep ${GREP_COLORS+--color=always} "$@" | mdw-pager
164 else
165 command $grep "$@"
166 fi
167 }
168 alias grep="greplike grep"
169 alias egrep="greplike egrep"
170 alias fgrep="greplike fgrep"
171 alias zgrep="greplike zgrep"
172
173 ## Turn off pagers inside Emacs shell buffers.
174 case "$INSIDE_EMACS" in
175 2[2-9].*,comint | [3-9][0-9].*,comint) export PAGER=cat ;;
176 esac
177
178 ###--------------------------------------------------------------------------
179 ### More complicated shell functions.
180
181 ## xt [@HOST] XTERM-ARGS
182 ##
183 ## Open a terminal, maybe on a remote host.
184 xt () {
185 case "$1" in
186 @*)
187 local remote=${1#@} title
188 shift
189 if [ $# -gt 0 ]; then
190 title="xterm [$remote] $1"
191 else
192 title="xterm [$remote]"
193 fi
194 (xterm -title "$title" -e ssh $remote "$@" &)
195 ;;
196 *)
197 (xterm "$@" &)
198 ;;
199 esac
200 }
201
202 ## core [y|n]
203 ##
204 ## Tweak core dumps on and off, or show the current status.
205 core () {
206 case "x$1" in
207 xon|xy|xyes) ulimit -Sc `ulimit -Hc` ;;
208 xoff|xn|xno) ulimit -Sc 0 ;;
209 x)
210 local l=`ulimit -Sc`
211 case $l in
212 0) echo "Core dumps disabled" ;;
213 unlimited) echo "Core dumps enabled" ;;
214 *) echo "Core dump limit is $l blocks" ;;
215 esac
216 ;;
217 *)
218 echo >&2 "usage: core [y|n]"
219 return 1
220 ;;
221 esac
222 }
223
224 ## world [NAME]
225 ##
226 ## Set current security world to NAME. With no NAME, print the currently
227 ## selected world.
228 world () {
229 local nfast=${NFAST_HOME-/opt/nfast}
230 local kmdata
231 case "$#" in
232 0)
233 echo "${NFAST_KMDATA#$nfast/kmdata-}"
234 ;;
235 *)
236 if [ -d "$1" ]; then
237 kmdata=$1
238 elif [ -d "$nfast/kmdata-$1" ]; then
239 kmdata=$nfast/kmdata-$1
240 else
241 echo >&2 "world: can't find world $1"
242 return 1
243 fi
244 shift
245 case "$#" in
246 0) export NFAST_KMDATA=$kmdata ;;
247 *) "$@" ;;
248 esac
249 ;;
250 esac
251 }
252
253 ## Fix `man' under Slowaris.
254 case "$MACHTYPE" in
255 *solaris*)
256 man () {
257 declare -i i=0
258 declare arg
259 declare -a man
260 for arg; do
261 case "$arg" in [0-9]*) man[i+=1]="-s" ;; esac
262 man[i+=1]="$arg"
263 done
264 command man "${man[@]}"
265 }
266 ;;
267 esac
268
269 ###--------------------------------------------------------------------------
270 ### Path hacks.
271
272 ## path-add [VAR] DIR
273 ##
274 ## Add DIR to the beginning of PATH-like variable VAR (defaults to PATH) if
275 ## it's not there already.
276 path-add () {
277 local pathvar export dir val
278 case $# in
279 1) pathvar=PATH dir=$1 export="export PATH";;
280 2) pathvar=$1 dir=$2 export=:;;
281 *) echo >&2 "Usage: $0 [VAR] DIR";;
282 esac
283 eval "val=\$$pathvar"
284 case ":$val:" in
285 *:"$dir":*) ;;
286 *) val=$dir:$val ;;
287 esac
288 eval "$pathvar=\$val"
289 $export
290 }
291
292 ## path-remove [VAR] DIR
293 ##
294 ## Remove DIR from PATH-like variable VAR (defaults to PATH); it's not an
295 ## error if DIR isn't in VAR.
296 path-remove () {
297 local pathvar export dir val
298 case $# in
299 1) pathvar=PATH dir=$1 export="export PATH";;
300 2) pathvar=$1 dir=$2 export=:;;
301 *) echo >&2 "Usage: $0 [VAR] DIR";;
302 esac
303 eval "val=\$$pathvar"
304 case ":$val:" in
305 :"$dir":) val= ;;
306 :"$dir":*) val=${val#$dir:} ;;
307 *:"$dir":) val=${val%:$dir} ;;
308 *:"$dir":*) val=${val/:$dir:/:} ;;
309 esac
310 eval "$pathvar=\$val"
311 $export
312 }
313
314 ## pathhack [-f] +HACK|-HACK...
315 ##
316 ## Each HACK refers to a subdirectory of `~/bin/hacks'. A hack name preceded
317 ## by `+' adds the directory to the PATH; a `-' removes. Adding a hack
318 ## that's already on the PATH doesn't do anything unless `-f' is set, in
319 ## which case it gets moved to the beginning. With no arguments, print the
320 ## currently installed hacks.
321 pathhack () {
322 if [ $# -eq 0 ]; then
323 local IFS=:
324 for e in $PATH; do
325 case "$e" in
326 "$HOME/bin/hacks/"*)
327 echo ${e#$HOME/bin/hacks/}
328 ;;
329 esac
330 done
331 return
332 fi
333 local force=nil
334 local path=$PATH
335 while [ $# -gt 0 ]; do
336 arg=$1
337 case "$arg" in
338 -f | --force)
339 force=t
340 shift
341 continue
342 ;;
343 --)
344 shift
345 break
346 ;;
347 [-+]*)
348 ;;
349 *)
350 break
351 ;;
352 esac
353 hack=${arg#[+-]}
354 dir=$HOME/bin/hacks/$hack
355 [ -d "$dir" ] || {
356 echo "$0: path hack $hack not found"
357 return 1
358 }
359 case "$arg,$force,:$PATH:" in
360 -*,*,*:"$dir":*)
361 path-remove path "$dir"
362 ;;
363 +*,t,*:"$dir":*)
364 path-remove path "$dir"
365 path-add path "$dir"
366 ;;
367 +*,nil,*:"$dir":*)
368 ;;
369 +*,*)
370 path-add path "$dir"
371 ;;
372 esac
373 shift
374 done
375 if [ $# -eq 0 ]; then
376 PATH=$path
377 export PATH
378 else
379 PATH=$path "$@"
380 fi
381 }
382
383 ###--------------------------------------------------------------------------
384 ### Finishing touches.
385
386 ## For `root' use -- some simple molly-guards.
387 if (( UID == 0 )); then
388 alias rm='rm -i' cp='cp -i' mv='mv -i'
389 set -o noclobber
390 fi
391
392 ## Run any local hooks.
393 [ -f "$HOME/.bashrc-local" ] && . "$HOME/.bashrc-local"
394
395 ## Close the `__mdw_bashrc' guard.
396 fi
397
398 ###----- That's all, folks --------------------------------------------------
399
400 :